'
'
' csv2usrc - csv to Unit Source (looks for x3units.csv and generates new-unit.usr in the current (CF) sub-folder)
'
' 
'
version$="csv2usrc - csv to Unit Source - Ver 1.1 2017-02-16 10:13"
'
' OK lets get started
PRINT version$
' NOTE QBasic can only deal for file name 8.3 (so .usr, not .usrc)
OPEN "C:\QBASIC\CF\x3units.csv" FOR INPUT AS #1
OPEN "C:\QBASIC\CF\x3units.usr" FOR OUTPUT AS #2
' New log (will overwrite previous)
OPEN "C:\QBASIC\CF\csv2usrc.log" FOR OUTPUT AS #4
'
'start the log
PRINT #4, "Logfile (.log) ";version$
'
' generate the header
PRINT #2, "[unitset]"
PRINT #2, "name = x3units"
PRINT #2, "icons = CFUnits.bmp"
'
'[unit]
'name(de) = Patrouillenboote
'name(en) = Patrol Boats
'name(fr) = Navire de Patrouille
'....(etc)
'type = ship
'type = sweeper
'icon = 60
'terrain = water
'terrain = shallowwater
'terrain = deepwater
'armour = 13
'speed = 8
'price = 18
'weight = 7
'power(ground) = 12
'power(ship) = 12
'power(air) = 8
'transslots = 5
'transminweight = 1
'transmaxweight = 1
'
' read the csv coulmn headings
' What we extect is:-
'name,ground,ship,aircraft,trooper,slow,mine,sweeper,medic,icon,road,rails,plains,forest,mountains,swamp,water,shallowwater,deepwater,rough,trenches,restricted,hills,armour,speed,price,weight,power(ground),min,max,power(ship),min,max,power(air),min,max,transslots,transminweight,transmaxweight,portrait
LINE INPUT #1, csvhead$
PRINT #4, "Reading column definitios, found:"
PRINT #4, csvhead$
' assume starts with name, chop name, then all up to icon is type
uname$="name(en) = "
cpos%=INSTR(csvhead$,",")
csvhead$=MID$(csvhead$,cpos%+1)
cpos%=INSTR(csvhead$,"icon")
' expected "ground,ship,aircraft,trooper,slow,mine,sweeper,medic,"
utype$ = LEFT$(csvhead$,cpos%-1)
PRINT #4, "uTypes headers = ";utype$
csvhead$=MID$(csvhead$,cpos%+5)
' all up to armour is terrain
cpos%=INSTR(csvhead$,"armour")
' expected "road,rails,plains,forest,mountains,swamp,water,shallowwater,deepwater,rough,trenches,hills,"
' (hills has been added for use in CF 6.0, no unit in 051 has hills type so should be safe to leave in)
uterrain$=LEFT$(csvhead$,cpos%-1)
PRINT #4, "uTerrain headers = ";uterrain$
PRINT #4, ""
' After this we have ...
'  armour = ,speed = ,price = ,weight =, 
' next is basic combat attack values (note, range is part of the power setting eg. power(ground) = 25 (2-6) )
'  power(ground) = n (min - max)
'  power(ship) = n (min - max)
'  power(air) = n (min - max)
' finally, the transport values and (optional) portrait file name
'  transslots =
'  transminweight =
'  transmaxweight =
'  portrait =
'
' OK lets read the csv defs
DO
LINE INPUT #1, in$
' 
PRINT #4, "Next line input: (";in$;")"
' skip blank lines
IF in$ = "" THEN GOTO skip0
' start the unit
PRINT #2, ""
PRINT #2, "[unit]"
' extract name
cpos%=INSTR(in$,",")
PRINT #2, uname$+LEFT$(in$,cpos%-1)
in$=MID$(in$,cpos%+1)
PRINT #4, "Line less name (";in$;")"
'
' step through checking the utype$
ptypes$=utype$
tloop0:
' extract next type name
ppos%=INSTR(ptypes$,",")
p$=LEFT$(ptypes$,ppos%-1)
ptypes$=MID$(ptypes$,ppos%+1)
' extract the setting
ipos%=INSTR(in$,",")
in$=MID$(in$,ipos%+1)
' if ipos>1, assume value = 1, i.e. this type
IF ipos%>1 THEN PRINT #2, "type = "+p$
' any more types ?
IF LEN(ptypes$)>1 THEN GOTO tloop0
'
' OK, done the type, now it's icon number
cpos%=INSTR(in$,",")
PRINT #2, "icon = "+LEFT$(in$,cpos%-1)
in$=MID$(in$,cpos%+1)
'
' nows it's terrain (just like type)
ptypes$=uterrain$
tloop1:
' extract next name
ppos%=INSTR(ptypes$,",")
p$=LEFT$(ptypes$,ppos%-1)
ptypes$=MID$(ptypes$,ppos%+1)
' extract the setting
ipos%=INSTR(in$,",")
in$=MID$(in$,ipos%+1)
' if ipos>1, assume value = 1, i.e. this type
IF ipos%>1 THEN PRINT #2, "terrain = "+p$
' any more names ?
IF LEN(ptypes$)>1 THEN GOTO tloop1
'
' now it's '  armour = ,speed = ,price = ,weight =, 
cpos%=INSTR(in$,",")
IF cpos%>1 THEN PRINT #2, "armour = "+LEFT$(in$,cpos%-1)
in$=MID$(in$,cpos%+1)
cpos%=INSTR(in$,",")
IF cpos%>1 THEN PRINT #2, "speed = "+LEFT$(in$,cpos%-1)
in$=MID$(in$,cpos%+1)
cpos%=INSTR(in$,",")
IF cpos%>1 THEN PRINT #2, "price = "+LEFT$(in$,cpos%-1)
in$=MID$(in$,cpos%+1)
cpos%=INSTR(in$,",")
IF cpos%>1 THEN PRINT #2, "weight = "+LEFT$(in$,cpos%-1)
in$=MID$(in$,cpos%+1)
'
' next is basic combat attack values (note, range is part of the power setting eg. power(ground) = 25 (2-6) )
'  power(ground) = n (min - max)
'  power(ship) = n (min - max)
'  power(air) = n (min - max)
' NOTE one or more may be 'blank' !
cpos%=INSTR(in$,",")
IF cpos%>1 THEN pg$="power(ground) = "+LEFT$(in$,cpos%-1) ELSE pg$=""
in$=MID$(in$,cpos%+1)
'
cpos%=INSTR(in$,",")
IF cpos%>1 THEN pg$=pg$+" ("+LEFT$(in$,cpos%-1)+"-"
in$=MID$(in$,cpos%+1)
cpos%=INSTR(in$,",")
IF cpos%>1 THEN pg$=pg$+LEFT$(in$,cpos%-1)+")"
in$=MID$(in$,cpos%+1)
IF pg$<>"" THEN PRINT #2, pg$
'
cpos%=INSTR(in$,",")
IF cpos%>1 THEN ps$="power(ship) = "+LEFT$(in$,cpos%-1) ELSE ps$=""
in$=MID$(in$,cpos%+1)
'
cpos%=INSTR(in$,",")
IF cpos%>1 THEN ps$=ps$+" ("+LEFT$(in$,cpos%-1)+"-"
in$=MID$(in$,cpos%+1)
cpos%=INSTR(in$,",")
IF cpos%>1 THEN ps$=ps$+LEFT$(in$,cpos%-1)+")"
in$=MID$(in$,cpos%+1)
IF ps$<>"" THEN PRINT #2, ps$
'
cpos%=INSTR(in$,",")
IF cpos%>1 THEN pa$="power(air) = "+LEFT$(in$,cpos%-1) ELSE pa$=""
in$=MID$(in$,cpos%+1)
'
cpos%=INSTR(in$,",")
IF cpos%>1 THEN pa$=pa$+" ("+LEFT$(in$,cpos%-1)+"-"
in$=MID$(in$,cpos%+1)
cpos%=INSTR(in$,",")
IF cpos%>1 THEN pa$=pa$+LEFT$(in$,cpos%-1)+")"
in$=MID$(in$,cpos%+1)
IF pa$<>"" THEN PRINT #2, pa$
'
' final set = transslots,transminweight,transmaxweight,portrait
cpos%=INSTR(in$,",")
IF cpos%>1 THEN PRINT #2, "transslots = "+LEFT$(in$,cpos%-1)
in$=MID$(in$,cpos%+1)
cpos%=INSTR(in$,",")
IF cpos%>1 THEN PRINT #2, "transminweight = "+LEFT$(in$,cpos%-1)
in$=MID$(in$,cpos%+1)
cpos%=INSTR(in$,",")
IF cpos%>1 THEN PRINT #2, "transmaxweight = "+LEFT$(in$,cpos%-1)
in$=MID$(in$,cpos%+1)
' last value = portrait
IF LEN(in$) > 1 THEN PRINT #2, "portrait = "+in$
'
skip0:
LOOP UNTIL EOF(1)

' all done, exit
PRINT #4, "Processing complete"
CLOSE
'
